using System;
using Microsoft.EntityFrameworkCore.Migrations;

#nullable disable

namespace PageFetcher.Data.Migrations
{
    /// <inheritdoc />
    public partial class InitialSchema : Migration
    {
        /// <inheritdoc />
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.EnsureSchema(
                name: MigrationConstants.SchemaName);

            migrationBuilder.CreateTable(
                name: "PageFetches",
                schema: MigrationConstants.SchemaName,
                columns: table => new
                {
                    Id = table.Column<string>(type: "nvarchar(64)", maxLength: 64, nullable: false),
                    Url = table.Column<string>(type: "nvarchar(2000)", maxLength: 2000, nullable: false),
                    CallerService = table.Column<string>(type: "nvarchar(64)", maxLength: 64, nullable: false),
                    HttpStatusCode = table.Column<int>(type: "int", nullable: true),
                    Html = table.Column<string>(type: "nvarchar(max)", nullable: false),
                    Text = table.Column<string>(type: "nvarchar(max)", nullable: false),
                    DurationMs = table.Column<long>(type: "bigint", nullable: false),
                    Success = table.Column<bool>(type: "bit", nullable: false),
                    ErrorMessage = table.Column<string>(type: "nvarchar(2000)", maxLength: 2000, nullable: true),
                    CreatedAt = table.Column<DateTime>(type: "datetime2", nullable: false, defaultValueSql: "SYSUTCDATETIME()")
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_PageFetches", x => x.Id);
                });

            migrationBuilder.CreateIndex(
                name: "IX_PageFetches_CreatedAt",
                schema: MigrationConstants.SchemaName,
                table: "PageFetches",
                column: "CreatedAt");

            migrationBuilder.CreateIndex(
                name: "IX_PageFetches_Url",
                schema: MigrationConstants.SchemaName,
                table: "PageFetches",
                column: "Url");
        }

        /// <inheritdoc />
        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropTable(
                name: "PageFetches",
                schema: MigrationConstants.SchemaName);
        }
    }
}
